#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>

/*
 * Build with:
 *
 * gcc -g -O0 -o thread2 thread2.c -lpthread
 *
*/

pthread_t tid[2];

void* doSomeThing(void *arg)
{
    unsigned long x = 0;
    unsigned int j = 0;
    int i = (int)arg;

    pthread_t id = pthread_self();

    printf("Thread[%d] processing...\n", i);
    if(pthread_equal(id,tid[0])) {
        printf("Inside First thread: Thread[%d]\n", i);
    } else  {
        printf("Inside Second thread: Thread[%d]\n", i);
    }
    /* consume some cpu */
    for(x=0; x<(0xFFFFFFFF);x++) {
        j++;
    }
    printf("Thread[%d]: 0x%lx [ x = 0x%X ]\n",i, id, j);

    pthread_exit((void*) i);
    return NULL;
}

int main(void)
{
    int i = 0;
    int err;
    void *status;

    while (i < 2) {
        err = pthread_create(&(tid[i]), NULL, &doSomeThing, (void*)i);
        if (err != 0)
            printf("can't create thread :[%s]", strerror(err));
        else
            printf("Thread[%d] created successfully\n", i);
        i++;
    }

    i = 0;
    while (i < 2) {
        err = pthread_join(tid[i], &status);
        if (err != 0)
            printf("can't wait for thread to finish :[%s]", strerror(err));
        else
            printf("Thread[%d] finished successfully with status: %ld\n", i, (long) status);
        i++;
    }

    // sleep(20);
    return 0;
}
